package com.ep.smslibrarysample;

import android.os.Bundle;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import java.util.ArrayList;

import com.ep.epsmsmanager.RestApi.SMSCallbacks;
import com.ep.epsmsmanager.RestApi.SMSManager;
import com.ep.epsmsmanager.model.param.BulkSMSParam;
import com.ep.epsmsmanager.model.param.CustomSMSParam;
import com.ep.epsmsmanager.model.param.MessageDetail;
import com.ep.epsmsmanager.model.param.SingleSMSParam;


public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        // Input your Account credentials, If you do not have an account yet, please write to support@tobeprecisesms.com for getting help.
        SMSManager.user = "Your User name";
        SMSManager.password = "Your Password";


        // To check the balance in your account before sending any SMS or to know if you have to purchase additional credits, use the method “GetBalance”.
        SMSManager.GetBalance(this,new SMSCallbacks() {
            @Override
            public void onSuccess(@NonNull String value) {
                // successful response here
                Log.d("","value="+value);
            }

            @Override
            public void onError(@NonNull Throwable throwable) {
                // Incase of error get error description here
                Log.d("","throwable="+throwable.getMessage());
            }


            @Override
            public void onValidateError(String errorMessage){
                // Incase of validation error get error description here
                Log.d("","errorMessage="+errorMessage);
            }
        });


        // Below method is used for sending SMS to one single number with minimal details.
        ArrayList<String> m_Numbers = new ArrayList<>();
        m_Numbers.add("971551234567");
        SMSManager.SingleSMS(new SingleSMSParam(m_Numbers, "This is sample", " XXXYYY "),this, new SMSCallbacks() {
            @Override
            public void onSuccess(@NonNull String value) {
                Log.d("","value="+value);
            }

            @Override
            public void onError(@NonNull Throwable throwable) {
                Log.d("","throwable="+throwable.getMessage());
            }

            @Override
            public void onValidateError(String errorMessage){
                Log.d("","errorMessage="+errorMessage);
            }
        });


        // Below method is used for sending SMS to one single number with additional details.Please refer the documentation for more information about parameters.
        SingleSMSParam singleSMSParam =new SingleSMSParam();
        singleSMSParam.setMobileNumbers(m_Numbers);
        singleSMSParam.setMessage("This is sample ");
        singleSMSParam.setSenderName("XXXYYY ");
        singleSMSParam.setReportRequired(true);
        singleSMSParam.setCallbackQueryString("paramX=12345&paramY=abc");
        singleSMSParam.setReferenceName("sample string 5");
        singleSMSParam.setBrightLinks(true);
        singleSMSParam.setBrightLinksBaseURL("http://prc.is");
        singleSMSParam.setBrightLinksFinalURL("http://www.example.com");
        SMSManager.SingleSMS(singleSMSParam,this, new SMSCallbacks() {
            @Override
            public void onSuccess(@NonNull String value) {
                Log.d("","value="+value);
            }

            @Override
            public void onError(@NonNull Throwable throwable) {
                Log.d("","throwable="+throwable.getMessage());
            }

            @Override
            public void onValidateError(String errorMessage){
                Log.d("","errorMessage="+errorMessage);
            }
        });


        //// Below method is used for sending SMS to one single number with additional details.Please refer the documentation for more information about parameters.
        singleSMSParam =new SingleSMSParam();
        singleSMSParam.setMobileNumbers(m_Numbers);
        singleSMSParam.setMessage("This is sample ");
        singleSMSParam.setSenderName("XXXYYY ");
        singleSMSParam.setReportRequired(true);
        singleSMSParam.setCallbackQueryString("paramX=12345&paramY=abc");
        singleSMSParam.setReferenceName("sample string 5");
        SMSManager.SingleSMS(singleSMSParam,this, new SMSCallbacks() {
            @Override
            public void onSuccess(@NonNull String value) {
                Log.d("","value="+value);
            }

            @Override
            public void onError(@NonNull Throwable throwable) {
                Log.d("","throwable="+throwable.getMessage());
            }

            @Override
            public void onValidateError(String errorMessage){
                Log.d("","errorMessage="+errorMessage);
            }
        });



        // BulkSMS method is similar to SingleSMS, except that here you can send the same message to multiple mobile numbers at the same time.
        ArrayList<String> mNumbers = new ArrayList<>();
        mNumbers.add("971551234567");
        mNumbers.add("971501234567");
        SMSManager.BulkSMS(new BulkSMSParam(mNumbers,"This is sample","XXXYYY"),this, new SMSCallbacks() {
            @Override
            public void onSuccess(@NonNull String value) {
                Log.d("","value="+value);
            }

            @Override
            public void onError(@NonNull Throwable throwable) {
                Log.d("","throwable="+throwable.getMessage());
            }

            @Override
            public void onValidateError(String errorMessage){
                Log.d("","errorMessage="+errorMessage);
            }
        });


        // BulkSMS method with additional details.Please refer the documentation for more information about parameters.
        BulkSMSParam bulkSMSParam=new BulkSMSParam();
        bulkSMSParam.setMobileNumbers(mNumbers);
        bulkSMSParam.setMessage("This is sample");
        bulkSMSParam.setSenderName("XXXYYY");
        bulkSMSParam.setScheduledDate("2019-09-29T14:49:59.5746271+04:00");
        bulkSMSParam.setRemoveDuplicates(true);
        bulkSMSParam.setReferenceName("sample string 5");
        bulkSMSParam.setReportRequired(false);
        bulkSMSParam.setCallbackQueryString("paramX=12345&paramY=abc");
        bulkSMSParam.setReturnIndividualResponse(true);
        bulkSMSParam.setAsynchronousSubmission(false);
        bulkSMSParam.setBrightLinks(true);
        bulkSMSParam.setBrightLinksBaseURL("http://prc.is");
        bulkSMSParam.setBrightLinksFinalURL("http://www.example.com");
        SMSManager.BulkSMS(bulkSMSParam,this, new SMSCallbacks() {
            @Override
            public void onSuccess(@NonNull String value) {
                Log.d("","value="+value);
            }

            @Override
            public void onError(@NonNull Throwable throwable) {
                Log.d("","throwable="+throwable.getMessage());
            }

            @Override
            public void onValidateError(String errorMessage){
                Log.d("","errorMessage="+errorMessage);
            }
        });


        // CustomSMS method allows you to send bulk SMS, but with the possibility to change the message for each number.
        ArrayList<MessageDetail> messageDetails = new ArrayList<>();
        MessageDetail messageDetail1 = new MessageDetail();
        messageDetail1.setTo("971501234567");
        messageDetail1.setMessage("This is sample message ");
        messageDetails.add(messageDetail1);

        MessageDetail messageDetail2 = new MessageDetail();
        messageDetail2.setTo("971551234567");
        messageDetail2.setMessage("This is second sample message ");
        messageDetails.add(messageDetail2);
        SMSManager.CustomSMS(new CustomSMSParam(messageDetails, "XXXYYY"), this,new SMSCallbacks() {
            @Override
            public void onSuccess(@NonNull String value) {
                Log.d("","value="+value);
            }

            @Override
            public void onError(@NonNull Throwable throwable) {
                Log.d("","throwable="+throwable.getMessage());
            }

            @Override
            public void onValidateError(String errorMessage){
                Log.d("","errorMessage="+errorMessage);
            }
        });


        //CustomSMS method with additional details.Please refer the documentation for more information about parameters.
        CustomSMSParam customSMSParam = new CustomSMSParam();
        customSMSParam.setMessageDetails(messageDetails); //Mandatory
        customSMSParam.setSenderName("XXXYYY "); 	//Mandatory
        customSMSParam.setScheduledDate("2019-09-29T14:51:05.6904323+04:00");
        customSMSParam.setRemoveDuplicates(true);
        customSMSParam.setReferenceName("sample string 4");
        customSMSParam.setReportRequired(true);
        customSMSParam.setCallbackQueryString("paramX=12345&paramY=abc");
        customSMSParam.setReturnIndividualResponse(true);
        customSMSParam.setAsynchronousSubmission(false);
        customSMSParam.setBrightLinks(true);
        customSMSParam.setBrightLinksBaseURL("http://prc.is");
        customSMSParam.setBrightLinksFinalURL("http://www.example.com");
        SMSManager.CustomSMS(customSMSParam, this,new SMSCallbacks() {
            @Override
            public void onSuccess(@NonNull String value) {
                Log.d("","value="+value);
            }

            @Override
            public void onError(@NonNull Throwable throwable) {
                Log.d("","throwable="+throwable.getMessage());
            }

            @Override
            public void onValidateError(String errorMessage){
                Log.d("","errorMessage="+errorMessage);
            }
        });




    }



}
